<!doctype html>
<html lang="en-us">
  <head>
    
    <meta charset="utf-8">
    <title>
      Concrete examples of HTMX and Django CBV
      
    </title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    
    
    
    
  <meta property="og:title" content="Clic to edit: user profile example">
  <meta property="og:url" content="/posts/clic-to-edit-user-profile-example.html">
  
  
  <meta name="twitter:card" content="summary_large_image">

    <link rel="stylesheet" href="/static/prism.css" type="text/css" />
    <link rel="stylesheet" href="/static/style.css" type="text/css" />
    <link rel="stylesheet" href="https://fonts.googleapis.com/css2?family=Lora&family=Space+Mono&display=swap" />

    <script src="/static/prism.js"></script>
    
  </head>
  <body>
    
    
      <header>
        <h1>
          <a href="/">
            Concrete examples of HTMX and Django CBV
          </a>
        </h1>
        <a href="#main" class="visually-hidden">jump to main content</a>
        <nav>
          <ul class="menu">
            <li><a href="/about">about</a></li>
            <li><a href="/">blog</a></li>
          </ul>
        </nav>
      </header>
    

    
    <main id="main">
      
  <article class="post">
    <h1 class="post__title">
      Clic to edit: user profile example
    </h1>
    <section class="post__meta">
      
        nov. 12, 2023
      
    </section>
    <section>
      <div id="outline-container-intro" class="outline-2">
<h2 id="intro">Intro</h2>
<div class="outline-text-2">
<p>
Here is a small tutorial on how to set up a editable user profile by using UpdateView and FormMixin.
My approach is based on a general template that includes an update HTML portion (user details or user form update).
URLs entries:
</p>
<ul class="org-ul">
<li>&ldquo;&rdquo;: render the template + detail partial template.</li>
<li>&ldquo;update/&rdquo;: render the form for profile editing.</li>
<li>&ldquo;detail/&rdquo;: render the user detail.</li>
</ul>
</div>
</div>
<div id="outline-container-model-customuser" class="outline-2">
<h2 id="model-customuser">Model: CustomUser</h2>
<div class="outline-text-2">
<div class="org-src-container">
<pre class="src src-python"><span style="color: #ff79c6;">from</span> django.contrib.auth.models <span style="color: #ff79c6;">import</span> AbstractUser
<span style="color: #ff79c6;">from</span> django.db <span style="color: #ff79c6;">import</span> models

<span style="color: #ff79c6;">class</span> <span style="color: #bd93f9;">CustomUser</span><span style="color: #61bfff;">(</span>AbstractUser<span style="color: #61bfff;">)</span>:
<span style="color: #40e748e26524;"> </span>   <span style="color: #ffc9e8;">email</span> = models.CharField<span style="color: #61bfff;">(</span>max_length=<span style="color: #bd93f9; font-weight: bold;">200</span>, null=<span style="color: #8be9fd;">True</span>, unique=<span style="color: #8be9fd;">True</span><span style="color: #61bfff;">)</span>
<span style="color: #40e748e26524;"> </span>   <span style="color: #ffc9e8;">first_name</span> = models.CharField<span style="color: #61bfff;">(</span><span style="color: #f1fa8c;">"first name"</span>, max_length=<span style="color: #bd93f9; font-weight: bold;">100</span><span style="color: #61bfff;">)</span>
<span style="color: #40e748e26524;"> </span>   <span style="color: #ffc9e8;">last_name</span> = models.CharField<span style="color: #61bfff;">(</span><span style="color: #f1fa8c;">"last name"</span>, max_length=<span style="color: #bd93f9; font-weight: bold;">100</span><span style="color: #61bfff;">)</span>
<span style="color: #40e748e26524;"> </span>   <span style="color: #ffc9e8;">adress</span> = models.CharField<span style="color: #61bfff;">(</span><span style="color: #f1fa8c;">"adress"</span>, max_length=<span style="color: #bd93f9; font-weight: bold;">300</span><span style="color: #61bfff;">)</span>
<span style="color: #40e748e26524;"> </span>   <span style="color: #ffc9e8;">phone</span> = models.IntegerField<span style="color: #61bfff;">(</span><span style="color: #f1fa8c;">"phone"</span>, null=<span style="color: #8be9fd;">True</span><span style="color: #61bfff;">)</span>
 
<span style="color: #40e748e26524;"> </span>   <span style="color: #ff79c6;">def</span> <span style="color: #50fa7b;">__str__</span><span style="color: #61bfff;">(</span><span style="color: #ff79c6;">self</span><span style="color: #61bfff;">)</span>:
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>   <span style="color: #ff79c6;">if</span> <span style="color: #ff79c6;">self</span>.first_name == <span style="color: #f1fa8c;">""</span> <span style="color: #ff79c6;">and</span> <span style="color: #ff79c6;">self</span>.last_name == <span style="color: #f1fa8c;">""</span>:
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>   <span style="color: #ff79c6;">return</span> f<span style="color: #f1fa8c;">"Unknown user </span>{<span style="color: #ff79c6;">self</span>.username}<span style="color: #f1fa8c;">"</span>
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>   <span style="color: #ff79c6;">return</span> f<span style="color: #f1fa8c;">"</span>{<span style="color: #ff79c6;">self</span>.first_name}<span style="color: #f1fa8c;"> </span>{<span style="color: #ff79c6;">self</span>.last_name}<span style="color: #f1fa8c;">"</span>
</pre>
</div>
</div>
</div>
<div id="outline-container-views-updateaccount" class="outline-2">
<h2 id="views-updateaccount">Views: UpdateAccount</h2>
<div class="outline-text-2">
<p>
By looking at the get request, I&rsquo;m able to know if the request is from HTMX or not. This means, I can render one of my partial templates inside my already rendered HTML page from &ldquo;&rdquo; URL entry. Also, if user is using directly &ldquo;detail/&rdquo; or &ldquo;update/&rdquo; URLs (instead of HTMX using them). It will render an HTML page with the general template + the corresponding partial template. In consequence, these URLs are still valid even if they&rsquo;re not used by HTMX request.
By default, partial template is set on detail, this is changed using &ldquo;update/&rdquo; URL.
</p>
<div class="org-src-container">
<pre class="src src-python"><span style="color: #ff79c6;">from</span> .models <span style="color: #ff79c6;">import</span> CustomUser
<span style="color: #ff79c6;">from</span> django.urls <span style="color: #ff79c6;">import</span> reverse_lazy
<span style="color: #ff79c6;">from</span> django.views.generic <span style="color: #ff79c6;">import</span> UpdateView

<span style="color: #ff79c6;">class</span> <span style="color: #bd93f9;">UpdateAccount</span><span style="color: #61bfff;">(</span>UpdateView<span style="color: #61bfff;">)</span>:
<span style="color: #40e748e26524;"> </span>   <span style="color: #ffc9e8;">model</span> = CustomUser
<span style="color: #40e748e26524;"> </span>   <span style="color: #ffc9e8;">form_class</span> = UpdateProfileForm
<span style="color: #40e748e26524;"> </span>   <span style="color: #ffc9e8;">template_name</span> = <span style="color: #f1fa8c;">"account/account.html"</span>
<span style="color: #40e748e26524;"> </span>   <span style="color: #ffc9e8;">partial_template</span> = <span style="color: #f1fa8c;">"account/detail.html"</span>
<span style="color: #40e748e26524;"> </span>   <span style="color: #ffc9e8;">success_url</span> = reverse_lazy<span style="color: #61bfff;">(</span><span style="color: #f1fa8c;">"account_detail"</span><span style="color: #61bfff;">)</span>
 
<span style="color: #40e748e26524;"> </span>   <span style="color: #ff79c6;">def</span> <span style="color: #50fa7b;">get_template_names</span><span style="color: #61bfff;">(</span><span style="color: #ff79c6;">self</span><span style="color: #61bfff;">)</span>:
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>   <span style="color: #ff79c6;">if</span> <span style="color: #ff79c6;">self</span>.request.META.get<span style="color: #61bfff;">(</span><span style="color: #f1fa8c;">"HTTP_HX_REQUEST"</span><span style="color: #61bfff;">)</span>:
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>   <span style="color: #ff79c6;">return</span> <span style="color: #61bfff;">[</span><span style="color: #ff79c6;">self</span>.partial_template<span style="color: #61bfff;">]</span>
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>   <span style="color: #ff79c6;">return</span> <span style="color: #61bfff;">[</span><span style="color: #ff79c6;">self</span>.template_name<span style="color: #61bfff;">]</span>
     
<span style="color: #40e748e26524;"> </span>   <span style="color: #ff79c6;">def</span> <span style="color: #50fa7b;">get_object</span><span style="color: #61bfff;">(</span><span style="color: #ff79c6;">self</span>, queryset=<span style="color: #8be9fd;">None</span><span style="color: #61bfff;">)</span>:
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>   <span style="color: #ff79c6;">return</span> <span style="color: #ff79c6;">self</span>.request.user
</pre>
</div>
</div>
</div>
<div id="outline-container-form-updateprofileform" class="outline-2">
<h2 id="form-updateprofileform">Form: UpdateProfileForm</h2>
<div class="outline-text-2">
<p>
Note that you could also use a fields attributes inside the UpdateView, this will construct the same form in less codes.
</p>
<div class="org-src-container">
<pre class="src src-python"><span style="color: #ff79c6;">from</span> django.forms <span style="color: #ff79c6;">import</span> ModelForm

<span style="color: #ff79c6;">class</span> <span style="color: #bd93f9;">UpdateProfileForm</span><span style="color: #61bfff;">(</span>ModelForm<span style="color: #61bfff;">)</span>:
<span style="color: #40e748e26524;"> </span>   <span style="color: #ff79c6;">class</span> <span style="color: #bd93f9;">Meta</span>:
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>   <span style="color: #ffc9e8;">model</span> = CustomUser
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>   <span style="color: #ffc9e8;">fields</span> = <span style="color: #61bfff;">(</span><span style="color: #f1fa8c;">"email"</span>, <span style="color: #f1fa8c;">"first_name"</span>, <span style="color: #f1fa8c;">"last_name"</span>, <span style="color: #f1fa8c;">"adress"</span>, <span style="color: #f1fa8c;">"phone"</span><span style="color: #61bfff;">)</span>
</pre>
</div>
</div>
</div>
<div id="outline-container-urls" class="outline-2">
<h2 id="urls">URLs</h2>
<div class="outline-text-2">
<p>
&ldquo;update/&rdquo; URL pass a new value to the partial_template attribute.
</p>
<div class="org-src-container">
<pre class="src src-python"><span style="color: #ff79c6;">from</span> django.urls <span style="color: #ff79c6;">import</span> path
<span style="color: #ff79c6;">from</span> .views <span style="color: #ff79c6;">import</span> UpdateAccount

<span style="color: #ffc9e8;">urlpatterns</span> = <span style="color: #61bfff;">[</span>
<span style="color: #40e748e26524;"> </span>   path<span style="color: #ff79c6;">(</span>
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>   <span style="color: #f1fa8c;">"update/"</span>,
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>   UpdateAccount.as_view<span style="color: #50fa7b;">(</span>partial_template=<span style="color: #f1fa8c;">"account/update.html"</span><span style="color: #50fa7b;">)</span>,
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>   name=<span style="color: #f1fa8c;">"account_update"</span>,
<span style="color: #40e748e26524;"> </span>   <span style="color: #ff79c6;">)</span>,
<span style="color: #61bfff;">]</span>
</pre>
</div>
</div>
</div>
<div id="outline-container-templates" class="outline-2">
<h2 id="templates">Templates</h2>
<div class="outline-text-2" id="text-templates">
</div>
<div id="outline-container-account-html" class="outline-3">
<h3 id="account-html">account.html</h3>
<div class="outline-text-3">
<div class="org-src-container">
<pre class="src src-html">{% extends 'base.html' %}

{% block title %}Mon profil{% endblock title %}

{% block content %}
<span style="color: #40e748e26524;"> </span> {% load static %}
<span style="color: #40e748e26524;"> </span> {% include "header/header.html" %}
<span style="color: #40e748e26524;"> </span> &lt;<span style="color: #50fa7b;">div</span> <span style="color: #ffc9e8;">id</span>=<span style="color: #f1fa8c;">"htmx_content"</span>&gt;
<span style="color: #40e748e26524;"> </span>   {% include "account/detail.html" %}
<span style="color: #40e748e26524;"> </span> &lt;/<span style="color: #50fa7b;">div</span>&gt;
 
<span style="color: #40e748e26524;"> </span> {% include "footer.html" %}
{% endblock content %}
</pre>
</div>
</div>
</div>
<div id="outline-container-detail-html" class="outline-3">
<h3 id="detail-html">detail.html</h3>
<div class="outline-text-3">
<div class="org-src-container">
<pre class="src src-html">{{ object.first_name }}
{{ object.last_name }}
{{ object.email }}
{{ object.adress }}
{{ object.phone }}
&lt;<span style="color: #50fa7b;">button</span> <span style="color: #ffc9e8;">hx-get</span>=<span style="color: #f1fa8c;">"{% url 'account_update' %}"</span>
<span style="color: #40e748e26524;"> </span>       <span style="color: #ffc9e8;">hx-target</span>=<span style="color: #f1fa8c;">"#htmx_content"</span>
<span style="color: #40e748e26524;"> </span>       hx-<span style="color: #f1fa8c;">"innerHTML"</span>&gt;Edit&lt;/<span style="color: #50fa7b;">button</span>&gt;
</pre>
</div>
</div>
</div>
<div id="outline-container-update-html" class="outline-3">
<h3 id="update-html">update.html</h3>
<div class="outline-text-3">
<div class="org-src-container">
<pre class="src src-html">&lt;<span style="color: #50fa7b;">form</span> <span style="color: #ffc9e8;">method</span>=<span style="color: #f1fa8c;">"put"</span> <span style="color: #ffc9e8;">hx-post</span>=<span style="color: #f1fa8c;">"{% url 'account_update' %}"</span>
<span style="color: #40e748e26524;"> </span>     <span style="color: #ffc9e8;">hx-target</span>=<span style="color: #f1fa8c;">"#htmx_content"</span>&gt;
<span style="color: #40e748e26524;"> </span> {% csrf_token %}
<span style="color: #40e748e26524;"> </span> {{ form }}
<span style="color: #40e748e26524;"> </span> &lt;<span style="color: #50fa7b;">button</span> <span style="color: #ffc9e8;">type</span>=<span style="color: #f1fa8c;">"submit"</span>&gt;Submit&lt;/<span style="color: #50fa7b;">button</span>&gt;
<span style="color: #40e748e26524;"> </span> &lt;<span style="color: #50fa7b;">button</span> <span style="color: #ffc9e8;">hx-get</span>=<span style="color: #f1fa8c;">"{% url 'account_detail' %}"</span>
<span style="color: #40e748e26524;"> </span>   <span style="color: #40e748e26524;"> </span>     <span style="color: #ffc9e8;">hx-target</span>=<span style="color: #f1fa8c;">"#htmx_content"</span>&gt;Cancel&lt;/<span style="color: #50fa7b;">button</span>&gt;
&lt;/<span style="color: #50fa7b;">form</span>&gt;
</pre>
</div>
</div>
</div>
</div>

    </section>
  </article>

    </main>

    
    
      <footer>&copy; Copyright 2023 Simon Chevolleau</footer>
    

  </body>
</html>
